<template>
  <dashboard-layout :link="3">
    <div v-if="isLoading" class="py-5 text-center">
      <vue-loaders class="py-5" name="ball-beat" color="#fa8357" scale="2"></vue-loaders>
    </div>
    <div v-else class="mb-4">
      <div v-if="curStep==0" class="m-2">
        <h3 class="text-dark my-2">Liste des utilisateurs</h3>
        <!-- <h3 v-else class="text-dark my-2">Liste des {{userType +'s'}}</h3> -->
        <div class="card mt-4 col-sm-12">
          <div class="row my-4 mx-2">
            <div class="fa-pull-left col-sm-3 form-group mt-2">
              <label class="mt-2 mr-2 text-dark col-sm-3" for="">Show : </label>
              <select class="ml-2 myform p-1 form-control-min col-sm-3" v-on:change="doPaginate" v-model="paginate">
                <option selected value="5">5</option>
                <option v-if="totalDatabase>5" value="10">10</option>
                <option v-if="totalDatabase>10" value="15">15</option>
                <option v-if="totalDatabase>15" value="20">20</option>
                <option v-if="totalDatabase>20" value="25">25</option>
                <option v-if="totalDatabase>25" value="50">50</option>
              </select>
            </div>
            <div class="col-sm-4 mt-2">
              <div class="input-group md-form form-sm form-2 pl-0">
                <input class="form-control form-control-min my-0 py-1 amber-border" v-model="searchtext"
                  type="search" placeholder="Search by firstname, lastname, email, ..." aria-label="Search">
                <div v-if="searchtext.length>2" class="btn bg-ejima c-pointer input-group-append py-2 px-3"
                  @click="loadData(curNumPage)">
                  <span class="" id="basic-text1">
                    <i class="fa fa-search " aria-hidden="true"></i>
                  </span>
                </div>
                <div v-else class="btn bg-outline-ejima c-pointer input-group-append py-2 px-3">
                  <span class="" id="basic-text1">
                    <i class="fa fa-search " aria-hidden="true"></i>
                  </span>
                </div>
              </div>
            </div>
            <div class="col-sm-2 mt-2">
              <span @click="loadData(0)" class="btn bg-ejima2 fa-pull-right">
                <i class="fa fa-refresh mr-2"></i>
                Refresh
              </span>
            </div>
            <div class="col-sm-3 mt-2">
              <span @click="goToAddUser" class="btn bg-ejima2 fa-pull-right" title="Ajouter un nouvel utilisateur">
                <i class="fa fa-plus mr-2"></i>
                Ajouter
              </span>
            </div>
          </div>
          <div class="card-body table-responsive">
            <table class="table table-striped">
              <thead>
                <tr>
                  <th>Avatar</th>
                  <th>Name</th>
                  <th>Email</th>
                  <th>Role</th>
                  <th>Status</th>
                  <!-- <th class="text-center">Action</th> -->
                </tr>              
              </thead>
              <tbody v-if="ressources && ressources.length > 0">
                <tr v-for="(user, i) in ressources" :key="i" class="">
                  <td>
                    <img src="../../assets/img/users_avatar.png" alt="user avatar" class="img-fluid users-avatar">
                  </td>
                  <td>
                    <span class="text-capitalize mr-2">{{user.firstname}} </span>
                    <span class="text-uppercase">{{user.lastname}}</span>
                  </td>
                  <td class="text-lowercase">{{ user.email }}</td>
                  <td class="text-capitalize">{{ user.role }}</td>
                  <td :class="user.statut && user.statut == true ? 'text-primary ' : ' text-secondary2 ' ">
                    {{ user.statut && user.statut == true ? 'Compte Actif' : 'compte Inactif' }}
                  </td>
                  <!-- <td class="text-center">
                    <span class="p-2 btn-edit" title="modifier" @click.stop="goToUpdate(i)">
                      <i class="fa text-white fa-pencil"></i>
                    </span>
                    <span></span>
                    <span class="m-2 p-2 btn-delete" title="supprimer">
                      <i class="fa fa-trash"></i>
                    </span>
                  </td> -->
                </tr>
              </tbody>
            </table>
            <div v-if="ressources && ressources.length == 0">
              <h3 class="text-primary2 mt-5 text-center">No match found</h3>
            </div>
          </div>
          <div class="d-flex justify-content-between align-items-center mb-5 mx-3">
            <p>Page {{curNumPage+1}} sur {{numPage}} </p>
            <nav class=''>
              <ul class="pagination justify-content-end">
                <li class="page-item">
                  <span v-if="curNumPage>0" class="page-link c-pointer text-primary2" aria-label="Previous" @click="loadData(curNumPage-1)">
                    <span aria-hidden="true">&laquo;</span>
                    <span class="sr-only">Previous</span>
                  </span>
                  <span v-else class="page-link text-primary2" aria-label="Previous">
                    <span aria-hidden="true">&laquo;</span>
                    <span class="sr-only">Previous</span>
                  </span>
                </li>
                <li class="page-item" v-for="(element, i) in numPage" :key="i">
                  <span v-if="curNumPage==i" :class="(curNumPage==i ? ' active2 text-white ' : ' text-dark') +' page-link c-pointer'" >{{i+1}}</span>
                  <span v-else :class="(curNumPage==i ? ' active2 text-white ' : ' text-dark') +' page-link c-pointer'" @click="loadData(i)" >{{i+1}}</span>
                </li>
                <li class="page-item">
                  <span v-if="numPage>curNumPage+1" class="page-link text-primary2 c-pointer" aria-label="Next" @click="loadData(curNumPage+1)">
                    <span aria-hidden="true">&raquo;</span>
                    <span class="sr-only">Next</span>
                  </span>
                  <span v-else class="page-link text-primary2" aria-label="Next">
                    <span aria-hidden="true">&raquo;</span>
                    <span class="sr-only">Next</span>
                  </span>
                </li>
              </ul>
            </nav>
          </div>
        </div>
      </div>
      <div v-if="curStep==1" class="m-2 card">
        <div class="row m-3">
          <div class="col-sm-3">
            <span class="ml-2 c-pointer text-dark" @click="goToList">Retour</span>
          </div>
          <h3 class="col-sm-6 text-center text-primary">Ajouter un nouvel utilisateur</h3>
          
        </div>
        <div class="mt-2 mb-5 mx-auto col-sm-5">
          <div class="alert alert-danger" v-if="errorMessage.length > 0">{{errorMessage}}</div>

          <form :class=" (toCheckRegister ? 'was-validated' : '') + ' '"  @submit="addUser">
            <div class="form-group">
              <label for="firstname" class="mt-2  text-primary2">First name</label>
              <input  class="form-control" v-model="newUser.firstname" required 
              placeholder="First name">
              <div class="invalid-feedback">
                Enter a First name!
              </div>
            </div>
            <div class="form-group">
              <label for="lastname" class="mt-2 text-primary2">Last name</label>
              <input  class="form-control text-uppercase" v-model="newUser.lastname" required 
              placeholder="Last name">
              <div class="invalid-feedback">
                Enter a Last name!
              </div>
            </div>
            <div class="form-group">
              <label for="password" class="mt-2 text-primary2">Email address</label>
              <input type="email" class="form-control " v-model="newUser.email" required 
              placeholder="Enter email">
              <div class="invalid-feedback">
                Enter a email address!
              </div>
            </div>
            <div class="form-group">
              <label for="password" class="mt-2 text-primary2">Role</label>
              <select name="" id="" class="form-control " v-model="newUser.role" required >
                <option selected value="reviewer">Reviewer</option>
                <option value="admin">Administrateur</option>
              </select>
              <div class="invalid-feedback">
                Enter a email address!
              </div>
            </div>
            <div class="form-group mt-2">
              <label for="password" class="mt-2 text-primary2">Password</label>
              <div class="input-group">
                <input :type="inputPwd2 ? 'password' : 'text'" minlength="8" class="form-control form-control-min"
                  title="At least 8 characters, a number, an upper case letter, a lower case letter and a special character"
                  pattern="(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[-+!#*$@%_]).{8,}" v-model="newUser.password" required 
                  placeholder="Enter password">

                <div class="input-group-prepend btn btn-outline-secondary" @click="inputPwd2=!inputPwd2">
                  <span class="" id="inputGroupPrepend">
                    <i v-if="inputPwd2==true" class="fa fa-eye"></i>
                    <i v-else class="fa fa-eye-slash"></i>
                  </span>
                </div>
                <div class="invalid-feedback">
                  Enter a Password!
                </div>
              </div>
            </div>

            <div class="form-group text-center" @click="toCheckRegister = true">
              <input type="submit" class="btn btn-primary mt-4 col-sm-12" value="Enregistrer">
            </div>

          </form>
        </div>
      </div>
    </div>
  </dashboard-layout>
</template>

<script lang="ts">

export default {
  head() {
    return {
      // title: "acma",
    };
  },
  data() {
    return {
      ressources: [],
      userType: 'all',

      newUser: {
        role: 'reviewer'
      },
      curStep: 0,
      toCheckRegister: false,
      inputPwd2: true,

      searchUser: '',
      searchtext: '',
      editing: false,
      errorMessage: '',
      curUser: [],
      isLoading: false,
      password: '',

      paginate: 5,
      showPaginate: false,
      numPage: 1,
      curNumPage: 0,
      totalDatabase: 1,
      checkCreate: false,
      checkUpdate: false,
      inputPwd : true,
      inputEditPwd: true,

    };
  },
  mounted() {
    this.loadData(this.curNumPage);
    this.curStep = 0;
  },
  methods: {
    loadData(index){
      this.isLoading = true;

      const query = {
        options: {
        },
        filter: {
          text: this.searchtext,
        },
        perPage: this.paginate,
        page: index,
        sort: {
          "createdAt": -1
        }
      };

      this.$service.list('users', query, (data) => {
        if(data.status == 200){
          this.isLoading = false;
          this.curNumPage = index;

          this.users = data.users;
          this.totalDatabase = data.count;
          this.ressources = data.users;

          this.numPage = 1;
          // Traitement pagination
          if(this.totalDatabase > this.paginate){
            this.numPage = Math.trunc(this.totalDatabase / this.paginate) ;

            if(this.numPage < (this.totalDatabase / this.paginate)){
              this.numPage +=1;
            }
          }
        } else {
          console.log("Data ", data);
        }
        this.curStep=0;

      });

    },
    goToAddUser(){
      this.curStep =1;
    },
    goToList(){
      this.curStep =0;
    },
    addUser(e){
      this.isLoading=true;
      e.preventDefault();

      const signup = {
        firstname: this.newUser.firstname,
        lastname: this.newUser.lastname,
        email: this.newUser.email,
        password: this.newUser.password,
        role: this.newUser.role,
        statut: true
        // password: this.encryptPassword(this.newUser.password)
      }

      this.$service.register(signup, (data) => {
        this.isLoading=false;
        console.log("Response : ",data);

        if(data.status == 200){
          this.errorMessage = '';
          this.newUser = {
            email: '',
            password: '',
            firstname: '',
            lastname: '',
            role: ''
          }
          this.loadData(0)

          // if(data.sendmail && data.sendmail==true){
            this.$alertify.alert('Enregistrement effectué avec succès!', 
              `Vous venez d'ajouter un nouvel utilisateur dans le système. Merci`
            );
          // }
          // this.$alertify.success('Inscripton éffectuée. Veuillez vous connecter!');
        } else {
          return this.errorMessage = data.message;
        }

      });
    
    },
    doPaginate(){
      this.curNumPage=0;
      this.numPage = Math.trunc(this.totalDatabase / this.paginate) ;

      if(this.numPage < this.totalDatabase / this.paginate){
        this.numPage +=1;
      }
      this.loadData(this.curNumPage);
    },
  },
};
</script>

<style lang="scss" scoped>

</style>
